MODULE MODE_BUDGET
USE MODD_BUDGET, ONLY : TBUDGETDATA
IMPLICIT NONE
CONTAINS

SUBROUTINE BUDGET_STORE_INIT(TPBUDGET, HSOURCE, PVARS)
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
END SUBROUTINE BUDGET_STORE_INIT
!
SUBROUTINE BUDGET_STORE_INIT_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_STORE_INIT(TPBUDGET, HSOURCE, PVARS)
END SUBROUTINE BUDGET_STORE_INIT_PHY
!
SUBROUTINE BUDGET_STORE_END(TPBUDGET, HSOURCE, PVARS)
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
END SUBROUTINE BUDGET_STORE_END
!
SUBROUTINE BUDGET_STORE_END_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_STORE_END(TPBUDGET, HSOURCE, PVARS)
END SUBROUTINE BUDGET_STORE_END_PHY
!
SUBROUTINE BUDGET_STORE_ADD_PHY(D,TPBUDGET, HSOURCE, PVARS)
  USE MODD_DIMPHYEX, ONLY: DIMPHYEX_t
  TYPE(DIMPHYEX_t),       INTENT(IN)    :: D
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(D%NIT,D%NJT,D%NKT), INTENT(IN)    :: PVARS    ! Current value to be stored
  CALL BUDGET_STORE_ADD(TPBUDGET, HSOURCE, PVARS)
END SUBROUTINE BUDGET_STORE_ADD_PHY
!
SUBROUTINE BUDGET_STORE_ADD(TPBUDGET, HSOURCE, PVARS)
  TYPE(TBUDGETDATA),      INTENT(INOUT) :: TPBUDGET ! Budget datastructure
  CHARACTER(LEN=*),       INTENT(IN)    :: HSOURCE  ! Name of the source term
  REAL, DIMENSION(:,:,:), INTENT(IN)    :: PVARS    ! Current value to be stored
  REAL, DIMENSION(SIZE(PVARS, 1), SIZE(PVARS, 2), SIZE(PVARS, 3)) :: ZVARS
END SUBROUTINE BUDGET_STORE_ADD
END MODULE MODE_BUDGET
